export function persist(storage, root = false) {
    const { set, initialValue, defaultValue, event } = storage;
    let state = $state(initialValue);
    const syncWithStorage = () => {
        $effect(() => set(state));
    };
    const listenStorageEvent = (event) => {
        if (event) {
            return event((value) => {
                state = value;
            });
        }
    };
    let cleanup = () => { };
    if (root) {
        cleanup = $effect.root(() => {
            syncWithStorage();
            return listenStorageEvent(event?.root);
        });
    }
    else {
        syncWithStorage();
        $effect(() => {
            return listenStorageEvent(event?.component);
        });
    }
    return {
        get value() {
            return state;
        },
        set value(value) {
            state = value;
        },
        cleanup,
        reset: () => {
            state = defaultValue;
        },
    };
}
